<?php

$format = $argv[1];
$output = $argv[2];
$files = array_slice($argv, 3);

($f = fopen($output, 'w')) || die("cannot open $output");

fwrite($f, "\n/* Generated by idl_list.php. Do NOT modify. */\n\n");

sort($files);
foreach ($files as $file) {
  preg_match('%^(?:.*/([^/]*)/)?(.*)\.idl\.php$%', $file, $matches);
  $prefix = $matches[1];
  $name = $matches[2];
  $ucname = $prefix ? camelCase($name) : ucfirst($name);

  switch ($format) {
  case 'inc':
    $path = $prefix ? "$prefix/" : "";
    fwrite($f, "#include \"$path$name.inc\"\n");
    break;
  case 'test_ext':
    $path = $prefix ?: "test";
    fwrite($f, "#include <$path/test_ext_$name.h>\n");
    break;
  case 'test_suites':
    fwrite($f, "RUN_TESTSUITE(TestExt$ucname);\n");
    break;
  case 'ext':
    $path = $prefix ?: "runtime/ext";
    fwrite($f, "#include <$path/ext_$name.h>\n");
    break;
  }
}

fclose($f);

function camelCase($name) {
  $names = explode('_', $name);
  return implode(array_map("ucfirst", $names));
}
